<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2 (rvision 50032)
#									########################
#					Dvelopp pour VirtueMart_multi
#						Version : 1.1.4
#						Compatibilit plateforme : V2
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						05/08/2013
#						Contact : support@payzen.eu
#
#####################################################################################################

global $PAYZEN_MULTI_LANG;

$GLOBALS['PAYZEN_MULTI_LANG'] = new ps_PAYZEN_MULTI_LANG();
$PAYZEN_MULTI_LANG->load('payzen_multi');

class ps_payzen_multi {

	var $payment_code = 'PAYZEN';
	var $classname = 'ps_payzen_multi';
	
	/* ********************* *
	 * ADMIN PARAMETERS FORM *
	 * ********************* */
	/**
     * Show all configuration parameters for this payment method
     *
     * @return boolean false when the payment method has no configration
     */
	function show_configuration() {
		global $PAYZEN_MULTI_LANG;
		
		$db = new ps_DB;
		
		// Read current configuration
		require_once(CLASSPATH . 'payment/' . $this->classname . '.cfg.php');

		echo '<table >';
		
		/*
		 * Module information
		 */
        echo $this->_write_title_config_line('PAYZEN_MULTI_MODULE_INFO_TITLE');
        
        echo '<tr>
        		<td style="padding-left: 150px; vertical-align: middle;"><img src="'.URL.'images/payzen_multi.jpg" alt="PayZen" /></td>
        	  	<td colspan="2"><table style="padding-left: 50px;">
	       		  <tr><td style="text-align: right;">' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_DEVELOPED_BY') . ' : </td><td><a href="http://www.lyra-network.com"><b>Lyra Network</b></a></td></tr>
	       		  <tr><td style="text-align: right;">' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_CONTACT_EMAIL') . ' : </td><td><a href="mailto:support@payzen.eu"><b>support@payzen.eu</b></a></td></tr>
	       		  <tr><td style="text-align: right;">' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_CONTRIB_VERSION') . ' : </td><td><b>1.2</b></td></tr>
	       		  <tr><td style="text-align: right;">' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_GATEWAY_VERSION') . ' : </td><td><b>V2</b></td></tr>
	       		  <tr><td style="text-align: right;">' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_CMS_VERSION') . ' : </td><td><b>VirtueMart 1.1.4</b></td></tr>
        	  	</table></td>
        	  </tr>';
        
		/*
		 * Payment gateway login
		 */
		echo $this->_write_title_config_line('PAYZEN_MULTI_GATEWAY_ACCESS_TITLE');
		
		echo $this->_write_simple_config_line('PAYZEN_MULTI_SITE_ID');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_KEY_TEST');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_KEY_PROD');

		$code = '<select name="PAYZEN_MULTI_CTX_MODE" class="inputbox">
					<option value="TEST"' . (PAYZEN_MULTI_CTX_MODE == 'TEST' ? ' selected="selected"' : '') . '>TEST</option>
					<option value="PRODUCTION"' . (PAYZEN_MULTI_CTX_MODE == 'PRODUCTION' ? ' selected="selected"' : '') . '>PRODUCTION</option>
				</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_CTX_MODE', $code, 'PAYZEN_MULTI_CTX_MODE_INFO');
		
		echo $this->_write_simple_config_line('PAYZEN_MULTI_PLATFORM_URL');
		
		/*
		 * Payment page settings
		 */
		echo $this->_write_title_config_line('PAYZEN_MULTI_PAYMENT_PAGE_TITLE');
		
		$api = new PayzenApi();
		
		$languages = array();
		foreach($api->getSupportedLanguages() as $key => $value) {
			$languages[$key] = $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_LANGUAGE_' . strtoupper($value));
		}
		$code = '<select name="PAYZEN_MULTI_LANGUAGE" class="inputbox">';
		foreach($languages as $key => $value) {
			$code .= '<option value="' . $key . '"' . (PAYZEN_MULTI_LANGUAGE == $key ? ' selected="selected"' : '') . '>' . $value . '</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_LANGUAGE', $code, 'PAYZEN_MULTI_LANGUAGE_INFO');
		
		// available languages 
		$selectedLangs = explode(';', PAYZEN_MULTI_AVAILABLE_LANGUAGES);
		
		$code = '<select name="PAYZEN_MULTI_AVAILABLE_LANGUAGES[]" size="6" multiple="multiple" class="inputbox">';
		$code .= '<option value=""' . (in_array('', $selectedLangs) ? ' selected="selected"' : '') . '>' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_AVAILABLE_LANGUAGES_ALL') . '</option>';
		foreach($languages as $key => $value) {
			$code .= '<option value="' . $key . '"' . (in_array($key, $selectedLangs) ? ' selected="selected"' : '') . '>' . $value . '</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_AVAILABLE_LANGUAGES', $code, 'PAYZEN_MULTI_AVAILABLE_LANGUAGES_INFO');
		
		// delay
		echo $this->_write_simple_config_line('PAYZEN_MULTI_CAPTURE_DELAY');
		
		// validation mode
		$code = '<select name="PAYZEN_MULTI_VALIDATION_MODE" class="inputbox">
					<option value=""' . (PAYZEN_MULTI_VALIDATION_MODE == '' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_VALIDATION_MODE_DEFAULT').'</option>
					<option value="0"' . (PAYZEN_MULTI_VALIDATION_MODE == '0' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_VALIDATION_MODE_AUTOMATIC').'</option>
					<option value="1"' . (PAYZEN_MULTI_VALIDATION_MODE == '1' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_VALIDATION_MODE_MANUAL').'</option>
				 </select>';
		echo $this->_write_config_line('PAYZEN_MULTI_VALIDATION_MODE', $code, 'PAYZEN_MULTI_VALIDATION_MODE_INFO');
		
		// payment cards
		$selectedCards = explode(';', PAYZEN_MULTI_PAYMENT_CARDS);
		
		$code = '<select name="PAYZEN_MULTI_PAYMENT_CARDS[]" size="4" multiple="multiple" class="inputbox">';
		$code .= '<option value=""' . (in_array('', $selectedCards) ? ' selected="selected"' : '') . '>' . $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_PAYMENT_CARDS_ALL') . '</option>';
		
		foreach($api->getSupportedCardTypes() as $key => $value) {
			$code .= '<option value="' . $key . '"' . (in_array($key, $selectedCards) ? ' selected="selected"' : '') . '>' . $value . '</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_PAYMENT_CARDS', $code, 'PAYZEN_MULTI_PAYMENT_CARDS_INFO');
		
		echo $this->_write_simple_config_line('PAYZEN_MULTI_THREEDS_MIN_AMOUNT');
		
		/*
		 * Multiple payment parameters
		*/
		echo $this->_write_title_config_line('PAYZEN_MULTI_INSTALLMENTS_TITLE');
		
		echo $this->_write_simple_config_line('PAYZEN_MULTI_AMOUNT_MIN');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_AMOUNT_MAX');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_COUNT');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_PERIOD');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_FIRST');
		
		/*
		 * Return parameters
		 */
		echo $this->_write_title_config_line('PAYZEN_MULTI_RETURN_TO_SHOP_TITLE');
		
		$code = '<select name="PAYZEN_MULTI_REDIRECT_ENABLED" class="inputbox">
					<option value="0"' . (PAYZEN_MULTI_REDIRECT_ENABLED == '0' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_DISABLED').'</option>
					<option value="1"' . (PAYZEN_MULTI_REDIRECT_ENABLED == '1' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_ENABLED').'</option>
				</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_REDIRECT_ENABLED', $code, 'PAYZEN_MULTI_REDIRECT_ENABLED_INFO');
		
		echo $this->_write_simple_config_line('PAYZEN_MULTI_REDIRECT_SUCCESS_TIMEOUT');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_REDIRECT_SUCCESS_MESSAGE');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_REDIRECT_ERROR_TIMEOUT');
		echo $this->_write_simple_config_line('PAYZEN_MULTI_REDIRECT_ERROR_MESSAGE');
		
		$code  = '<select name="PAYZEN_MULTI_RETURN_MODE" class="inputbox">';
		$code .= '	<option value="GET"'.(PAYZEN_MULTI_RETURN_MODE=='GET' ? ' selected="selected"' : '').'>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_RETURN_MODE_GET').'</option>';
		$code .= '	<option value="POST"'.(PAYZEN_MULTI_RETURN_MODE=='POST' ? ' selected="selected"' : '').'>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_RETURN_MODE_POST').'</option>';
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_RETURN_MODE', $code, 'PAYZEN_MULTI_RETURN_MODE_INFO');
		
		// successful order status
		$orderStatuses = array();
		$db->query("SELECT order_status_name, order_status_code FROM #__{vm}_order_status ORDER BY list_order");
		while ($db->next_record() ) {
			$orderStatuses[$db->f("order_status_code" )] = $db->f("order_status_name" );
		}
		
		$code = '<select name="PAYZEN_MULTI_VERIFIED_STATUS" class="inputbox" >';
		foreach($orderStatuses as $statusCode => $statusLabel) {
			$code .= '<option value="' . $statusCode . '"' . (PAYZEN_MULTI_VERIFIED_STATUS == $statusCode ? ' selected="selected"' : '') . '>' . $statusLabel . '</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_VERIFIED_STATUS', $code, 'PAYZEN_MULTI_VERIFIED_STATUS_INFO');
		
		// failed order status
		$code = '<select name="PAYZEN_MULTI_INVALID_STATUS" class="inputbox" >';
		foreach($orderStatuses as $statusCode => $statusLabel) {
			$code .= '<option value="' . $statusCode . '"' . (PAYZEN_MULTI_INVALID_STATUS == $statusCode ? ' selected="selected"' : '') . '>' . $statusLabel . '</option>';
		}
		$code .= '</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_INVALID_STATUS', $code, 'PAYZEN_MULTI_INVALID_STATUS_INFO');
		
		// enable / disable payment notification
		$code = '<select name="PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED" class="inputbox">
					<option value="0"' . (PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED == '0' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_DISABLED').'</option>
					<option value="1"' . (PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED == '1' ? ' selected="selected"' : '') . '>'.$PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_ENABLED').'</option>
				</select>';
		echo $this->_write_config_line('PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED', $code, 'PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED_INFO');
		
		/*
		 * Extra information
		 */
		echo $this->_write_title_config_line('PAYZEN_MULTI_EXTRA_SETTINGS_TITLE');
		
		echo $this->_write_config_line('PAYZEN_MULTI_URL_CHECK', URL . 'index.php?page=checkout.payzen_multi_rsts&amp;option=com_virtuemart');
		echo $this->_write_config_line('PAYZEN_MULTI_EXTRA_CODE', htmlentities('<?php require_once(PAGEPATH . "checkout.payzen_multi_form.php"); ?>'));
		
		echo '</table>';
		return true;
	}
	
	function _write_title_config_line($title_code) {
		global $PAYZEN_MULTI_LANG;
		
		return '<tr><td colspan="3" style="font-weight: bold; background-color: #D2D2D2; padding-top: 7px; padding-bottom: 7px;">'.$PAYZEN_MULTI_LANG->_($title_code).'</td></tr>';
	}
	
	/**
	 *
	 * Builds and returns html code for an administration text parameter
	 * @param $param_name
	 */
	function _write_simple_config_line($param_name) {
		$label_name = $param_name;
		$input_code = '<input type="text" name="'.$param_name.'" class="inputbox" value="'.constant($param_name).'" />';
		$desc_name = $param_name.'_INFO';
		return $this->_write_config_line($label_name, $input_code, $desc_name);
	}
	
	/**
	 *
	 * Builds and returns html code for an administration parameter
	 * @param $label_name
	 * @param $input_code
	 * @param $desc_name
	 */
	function _write_config_line($label_name, $input_code, $desc_name=false) {
		global $PAYZEN_MULTI_LANG;
		
		static $cpt = 0;
		$cpt++;
		$color = ($cpt % 2 == 1) ? ' background-color: #e4e4e4;' : '';
		$code = '<tr style="padding: 3px;' . $color . '">';
		$code .= '<td style="text-align: right; padding-right: 10px; width: 250px;">' . $PAYZEN_MULTI_LANG->_($label_name) . '</td>';
		$code .= '<td' . ($desc_name == false ? ' colspan="2"' : '') . ' style="width: 250px;">'.$input_code.'</td>';
		if($desc_name) {
			$code .= '<td><span style="font-family: Verdana,Geneva,sans-serif; font-size: 10px; font-weight: normal;">' . $PAYZEN_MULTI_LANG->_($desc_name) . '</span></td>';
		}
		$code .= '</tr>';
		
		return $code;
	}
	
	/**
	 * Convert array to string values separated with delimiter ";" 
	 * @param $values
	 */
	function _serialize_array($values) {
		if(!is_null($values) && is_array($values) && count($values) > 0 && !in_array('', $values)) {
			return implode(';', $values);
		} else {
			return '';
		}
	}
	
	/**
	 * Checks if module is available for use. Needs a modification in virtuemart code.
	 * @return true if module is available
	 */
	function is_active() {
		global $order_total;
	
		// read current configuration
		require_once(CLASSPATH . 'payment/' . $this->classname . '.cfg.php' );
	
		// minimum and maximum amount restrictions
		if ((defined('PAYZEN_MULTI_AMOUNT_MIN') && PAYZEN_MULTI_AMOUNT_MIN != '' && $order_total < PAYZEN_MULTI_AMOUNT_MIN)
				|| (defined('PAYZEN_MULTI_AMOUNT_MAX') && PAYZEN_MULTI_AMOUNT_MAX != '' && $order_total > PAYZEN_MULTI_AMOUNT_MAX)) {
	
			return false;
		}
	
		return true;
	}
	
	/* *************************** *
	 * VIRTUEMART CONFIG FUNCTIONS *
	 * *************************** */
	function has_configuration() {
		return true;
	}
	
	function configfile_writeable() {
		return is_writeable(CLASSPATH . 'payment/' . $this->classname . '.cfg.php' );
	}
	
	function configfile_readable() {
		return is_readable(CLASSPATH . 'payment/' . $this->classname . '.cfg.php' );
	}
	
	/**
    * Writes the configuration file for this payment method
    *
    * @param array $data An array of objects
    * @returns boolean True when writing was successful
    */
	function write_configuration(&$data) {
		$config = <<<HEADER
<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.2 (rvision 50032)
#									########################
#					Dvelopp pour VirtueMart_multi
#						Version : 1.1.4
#						Compatibilit plateforme : V2
#									########################
#					Dvelopp par Lyra Network
#						http://www.lyra-network.com/
#						05/08/2013
#						Contact : support@payzen.eu
#
#####################################################################################################
HEADER;
		
		$config .= "\n\n// FILE GENERATED BY ps_payzen_multi.php on " . date('Y-m-d H:i:s');
		$config .= "\n\nif(!defined('_VALID_MOS') && !defined('_JEXEC')) die('Direct Access to ' . basename(__FILE__) . ' is not allowed.');\n\n";

		$defaultValues = array(
				'PAYZEN_MULTI_SITE_ID' => '12345678',
				'PAYZEN_MULTI_KEY_TEST' => '1111111111111111',
				'PAYZEN_MULTI_KEY_PROD' => '2222222222222222',
				'PAYZEN_MULTI_CTX_MODE' => 'TEST',
				'PAYZEN_MULTI_PLATFORM_URL' => 'https://secure.payzen.eu/vads-payment/',
				
				'PAYZEN_MULTI_LANGUAGE' => 'fr',
				'PAYZEN_MULTI_AVAILABLE_LANGUAGES' => '',
				'PAYZEN_MULTI_CAPTURE_DELAY' => '',
				'PAYZEN_MULTI_VALIDATION_MODE' => '',
				'PAYZEN_MULTI_PAYMENT_CARDS' => '',
				'PAYZEN_MULTI_THREEDS_MIN_AMOUNT' => '',
				
				'PAYZEN_MULTI_AMOUNT_MIN' => '',
				'PAYZEN_MULTI_AMOUNT_MAX' => '',
				'PAYZEN_MULTI_COUNT' => 3,
				'PAYZEN_MULTI_PERIOD' => 30,
				'PAYZEN_MULTI_FIRST' => '',
				
				'PAYZEN_MULTI_REDIRECT_ENABLED' => '0',
				'PAYZEN_MULTI_REDIRECT_SUCCESS_TIMEOUT' => '5',
				'PAYZEN_MULTI_REDIRECT_SUCCESS_MESSAGE' => 'Redirection vers la boutique dans quelques instants...',
				'PAYZEN_MULTI_REDIRECT_ERROR_TIMEOUT' => '5',
				'PAYZEN_MULTI_REDIRECT_ERROR_MESSAGE' => 'Redirection vers la boutique dans quelques instants...',
				'PAYZEN_MULTI_RETURN_MODE' => 'GET',
				'PAYZEN_MULTI_VERIFIED_STATUS' => 'C',
				'PAYZEN_MULTI_INVALID_STATUS' => 'P',
				'PAYZEN_MULTI_NOTIFY_CUSTOMER_ENABLED' => '0'
		);
		
		foreach($defaultValues as $key => $default) {
			if (!array_key_exists($key, $data)) {
				$value = $default;
			} elseif(is_array($data[$key])) {
				$value = $this->_serialize_array($data[$key]);
			} else {
				$value = $data[$key];
			}
				
			$value = mysql_escape_string($value);	// avoid problems with values containing '
			$config .= "\ndefine ('$key', '$value');";
		}

		$config .= "\n?>";

		if ($fp = fopen(CLASSPATH . "payment/" . $this->classname . ".cfg.php", "w" ) ) {
			fputs($fp, $config, strlen($config ) );
			fclose ($fp );
		} else {
			global $PAYZEN_MULTI_LANG;
			
			$d['error'] = $PAYZEN_MULTI_LANG->_('PAYZEN_MULTI_CONFIG_ERROR') . CLASSPATH . 'payment/' . $this->classname . '.cfg.php';
			return false;
		}

		return true;
	}


	/**
     *
     */
	function process_payment($order_number, $order_total, &$d) {
		return true;
	}
	
	/**
	 * Function used in response processing pages. Updates an order status with payment result data
	 */
	function update_order($response, $status, $notify = false) {
		$d = array();
		$d['order_id'] = $response->get('order_id');
		$d['order_status'] = $status;
		$d['notify_customer'] = $notify ? 'Y' : 'N';
		$d['include_comment'] = 'Y';
		$d['order_comment'] = htmlentities($response->message . '. ' . ($response->authMessage != '' ? $response->authMessage : ''), ENT_QUOTES);
		
		$ps_order = new ps_order;
		$ps_order->order_status_update($d);
		
		$db = new ps_DB;
		$q  = "UPDATE #__{vm}_order_payment SET ";
		$q .= "order_payment_log='".htmlentities($response->getLogString())."',";
		$q .= "order_payment_trans_id='".$response->get('trans_id')."', ";
		$q .= "order_payment_number=" . VM_ENCRYPT_FUNCTION . "('" . $response->get('card_number') . "', '" . ENCODE_KEY . "'), ";
		$q .= "order_payment_expire='". strtotime($response->get('expiry_year') . '-' . $response->get('expiry_month') . '-15') . "', ";
		$q .= "order_payment_name='".$response->get('card_brand')."' ";
		$q .= "WHERE order_id='".$response->get('order_id')."' ";
		$db->query($q);
	}
}


class ps_PAYZEN_MULTI_LANG extends vmAbstractLanguage {
	// Override basic language class with french as default language
	function ps_PAYZEN_MULTI_LANG() {
		$this->setDebug();
	}
	
	function load($module) {
		if($module === 'payzen_multi') {
			global $mosConfig_lang;
			
			if (file_exists( ADMINPATH . 'languages/payzen_multi/' . $mosConfig_lang.'.php')) {
				require_once( ADMINPATH . 'languages/payzen_multi/' . $mosConfig_lang.'.php');
			} else if (file_exists( ADMINPATH . 'languages/payzen_multi/french.php')) {
				require_once( ADMINPATH . 'languages/payzen_multi/french.php');
			}
		}
	}
}


/**
 * @package payzen
 * @author Alain Dubrulle <supportvad@lyra-network.com>
 * @copyright www.lyra-network.com
 * PHP classes to integrate an e-commerce solution with the payment platform supported by lyra-network.
 */

if(!@class_exists('PayzenApi', false)) {
	/**
	 * Class managing parameters checking, form and signature building, response analysis and more
	 * @version 2.2
	 */
	class PayzenApi {
		// **************************************
		// PROPERTIES
		// **************************************
		/**
		 * The fields to send to the PayZen platform
		 * @var array[string]PayzenField
		 * @access private
		 */
		var $requestParameters;
		/**
		 * Certificate to send in TEST mode
		 * @var string
		 * @access private
		 */
		var $keyTest;
		/**
		 * Certificate to send in PRODUCTION mode
		 * @var string
		 * @access private
		 */
		var $keyProd;
		/**
		 * Url of the payment page
		 * @var string
		 * @access private
		 */
		var $platformUrl;
		/**
		 * Set to true to send the redirect_* parameters
		 * @var boolean
		 * @access private
		 */
		var $redirectEnabled;
		/**
		 * SHA-1 authentication signature
		 * @var string
		 * @access private
		 */
		var $signature;
		/**
		 * The original data encoding.
		 * @var string
		 * @access private
		 */
		var $encoding;
		
		/**
		 * The list of categories for payment with bank accord. To be sent with the products detail if you use this payment mean.
		 * @static
		 * @var array
		 * @access public
		 */
		var $ACCORD_CATEGORIES = array("FOOD_AND_GROCERY","AUTOMOTIVE","ENTERTAINMENT","HOME_AND_GARDEN","HOME_APPLIANCE","AUCTION_AND_GROUP_BUYING","FLOWERS_AND_GIFTS","COMPUTER_AND_SOFTWARE","HEALTH_AND_BEAUTY","SERVICE_FOR_INDIVIDUAL","SERVICE_FOR_BUSINESS","SPORTS","CLOTHING_AND_ACCESSORIES","TRAVEL","HOME_AUDIO_PHOTO_VIDEO","TELEPHONY");
	
		/**
		* The list of encodings supported by this API.
		* @static
		* @var array
		* @access public
		*/
		var $SUPPORTED_ENCODINGS = array("UTF-8", "ASCII", "Windows-1252", "ISO-8859-15", "ISO-8859-1", "ISO-8859-6", "CP1256");
		
		// **************************************
		// CONSTRUCTOR
		// **************************************
		/**
		 * Constructor.
		 * Initialize request fields definitions.
		 */
		function PayzenApi($encoding="UTF-8") {
			// Initialize encoding
			$this->encoding = in_array(strtoupper($encoding), $this->SUPPORTED_ENCODINGS) ? strtoupper($encoding) : "UTF-8"; 
			
			/*
			 * Dfinition des paramtres de la requte
			 */
			// Common or long regexes
			$ans = "[^<>]"; // Any character (except the dreadful "<" and ">")
			$an63 = '#^[A-Za-z0-9]{0,63}$#';
			$an255 = '#^[A-Za-z0-9]{0,255}$#';
			$ans255 = '#^' . $ans . '{0,255}$#';
			$ans127 = '#^' . $ans . '{0,127}$#';
			$supzero = '[1-9]\d*';
			$regex_payment_cfg = '#^(SINGLE|MULTI:first=\d+;count=' . $supzero
					. ';period=' . $supzero . ')$#';
			$regex_trans_date = '#^\d{4}' . '(1[0-2]|0[1-9])'
					. '(3[01]|[1-2]\d|0[1-9])' . '(2[0-3]|[0-1]\d)' . '([0-5]\d){2}$#';//AAAAMMJJhhmmss
			$regex_mail = '#^[^@]+@[^@]+\.\w{2,4}$#'; //TODO plus restrictif
			$regex_params = '#^([^&=]+=[^&=]*)?(&[^&=]+=[^&=]*)*$#'; //name1=value1&name2=value2...
	
			// Dclaration des paramtres, de leur valeurs par dfaut, de leur format...
			// 		$this->_addRequestField('raw_signature', 'DEBUG Signature', '#^.+$#', false);
			$this->_addRequestField('signature', 'Signature', "#^[0-9a-f]{40}$#", true);
			$this->_addRequestField('vads_action_mode', 'Action mode',
							"#^INTERACTIVE|SILENT$#", true, 11);
			$this->_addRequestField('vads_amount', 'Amount', '#^' . $supzero . '$#',
							true);
			$this->_addRequestField('vads_available_languages', 'Available languages',
							"#^(|[A-Za-z]{2}(;[A-Za-z]{2})*)$#", false, 2);
			$this->_addRequestField('vads_capture_delay', 'Capture delay', "#^\d*$#");
			$this->_addRequestField('vads_contracts', 'Contracts', $ans255);
			$this->_addRequestField('vads_contrib', 'Contribution', $ans255);
			$this->_addRequestField('vads_ctx_mode', 'Mode', "#^TEST|PRODUCTION$#",
							true);
			$this->_addRequestField('vads_currency', 'Currency', "#^\d{3}$#", true, 3);
			$this->_addRequestField('vads_cust_antecedents', 'Customer history',
							"#^NONE|NO_INCIDENT|INCIDENT$#");
			$this->_addRequestField('vads_cust_address', 'Customer address', $ans255);
			$this->_addRequestField('vads_cust_country', 'Customer country',
							"#^[A-Za-z]{2}$#", false, 2);
			$this->_addRequestField('vads_cust_email', 'Customer email', $regex_mail,
							false, 127);
			$this->_addRequestField('vads_cust_id', 'Customer id',
							$an63, false, 63);
			$this->_addRequestField('vads_cust_name', 'Customer name',
							$ans127, false, 127);
			$this->_addRequestField('vads_cust_cell_phone', 'Customer cell phone',
							$an63, false, 63);
			$this->_addRequestField('vads_cust_phone', 'Customer phone', $an63, false,
							63);
			$this->_addRequestField('vads_cust_title', 'Customer title', '#^'.$ans.'{0,63}$#', false,
							63);
			$this->_addRequestField('vads_cust_city', 'Customer city',
							'#^' . $ans . '{0,63}$#', false, 63);
			$this->_addRequestField('vads_cust_state', 'Customer state/region', '#^'.$ans.'{0,63}$#', false,
							63);
			$this->_addRequestField('vads_cust_zip', 'Customer zip code', $an63, false,
							63);
			$this->_addRequestField('vads_language', 'Language', "#^[A-Za-z]{2}$#",
							false, 2);
			$this->_addRequestField('vads_order_id', 'Order id',
							"#^[A-za-z0-9]{0,12}$#", false, 12);
			$this->_addRequestField('vads_order_info', 'Order info', $ans255);
			$this->_addRequestField('vads_order_info2', 'Order info 2', $ans255);
			$this->_addRequestField('vads_order_info3', 'Order info 3', $ans255);
			$this->_addRequestField('vads_page_action', 'Page action', "#^PAYMENT$#",
							true, 7);
			$this->_addRequestField('vads_payment_cards', 'Payment cards',
							"#^([A-Za-z0-9\-_]+;)*[A-Za-z0-9\-_]*$#", false, 127);
			$this->_addRequestField('vads_payment_config', 'Payment config',
							$regex_payment_cfg, true);
			$this->_addRequestField('vads_payment_src', 'Payment source', "#^$#", false,
							0);
			$this->_addRequestField('vads_redirect_error_message',
							'Redirection error message', $ans255, false);
			$this->_addRequestField('vads_redirect_error_timeout',
							'Redirection error timeout', $ans255, false);
			$this->_addRequestField('vads_redirect_success_message',
							'Redirection success message', $ans255, false);
			$this->_addRequestField('vads_redirect_success_timeout',
							'Redirection success timeout', $ans255, false);
			$this->_addRequestField('vads_return_mode', 'Return mode',
							"#^NONE|GET|POST?$#", false, 4);
			$this->_addRequestField('vads_return_get_params', 'GET return parameters',
							$regex_params, false);
			$this->_addRequestField('vads_return_post_params',
							'POST return parameters', $regex_params, false);
			$this->_addRequestField('vads_ship_to_name', 'Shipping name',
							'#^' . $ans . '{0,127}$#', false, 127);
			$this->_addRequestField('vads_ship_to_phone_num', 'Shipping phone',
							$ans255, false, 63);
			$this->_addRequestField('vads_ship_to_street', 'Shipping street', $ans127,
							false, 127);
			$this->_addRequestField('vads_ship_to_street2', 'Shipping street (2)',
							$ans127, false, 127);
			$this->_addRequestField('vads_ship_to_state', 'Shipping state', $an63,
							false, 63);
			$this->_addRequestField('vads_ship_to_country', 'Shipping country',
							"#^[A-Za-z]{2}$#", false, 2);
			$this->_addRequestField('vads_ship_to_city', 'Shipping city',
							'#^' . $ans . '{0,63}$#', false, 63);
			$this->_addRequestField('vads_ship_to_zip', 'Shipping zip code', $an63,
							false, 63);
			$this->_addRequestField('vads_shop_name', 'Shop name', $ans127);
			$this->_addRequestField('vads_shop_url', 'Shop url', $ans127);
			$this->_addRequestField('vads_site_id', 'Site id', "#^\d{8}$#", true, 8);
			$this->_addRequestField('vads_theme_config', 'Theme', $ans255);
			$this->_addRequestField('vads_trans_date', 'Transaction date',
							$regex_trans_date, true, 14);
			$this->_addRequestField('vads_trans_id', 'Transaction id',
							"#^[0-8]\d{5}$#", true, 6);
			$this->_addRequestField('vads_url_success', 'Success url', $ans127, false,
							127);
			$this->_addRequestField('vads_url_referral', 'Referral url', $ans127,
							false, 127);
			$this->_addRequestField('vads_url_refused', 'Refused url', $ans127, false,
							127);
			$this->_addRequestField('vads_url_cancel', 'Cancel url', $ans127, false,
							127);
			$this->_addRequestField('vads_url_error', 'Error url', $ans127, false, 127);
			$this->_addRequestField('vads_url_return', 'Return url', $ans127, false,
							127);
			$this->_addRequestField('vads_user_info', 'User info', $ans255);
			$this->_addRequestField('vads_validation_mode', 'Validation mode',
							"#^[01]?$#", false, 1);
			$this->_addRequestField('vads_version', 'Gateway version', "#^V2$#", true,
							2);
			
			// Credit Card info
			$this->_addRequestField('vads_card_number', 'Card number', "#^\d{13,19}$#");
			$this->_addRequestField('vads_cvv', 'Card verification number', "#^\d{3,4}$#");
			$this->_addRequestField('vads_expiry_year', 'Year of card expiration', "#^20[0-9]{2}$#");
			$this->_addRequestField('vads_expiry_month', 'Month of card expiration', "#^\d[0-2]{1}$#");
			
			// Enable / disable 3D Secure 
			$this->_addRequestField('vads_threeds_mpi', 'Enable / disable 3D Secure', '#^[0-2]$#', false);
			
			// Declaration of parameters for Oney payment
			$this->_addRequestField('vads_cust_first_name', 'Customer first name', $an63, false, 63);
			$this->_addRequestField('vads_cust_last_name', 'Customer last name', $an63, false, 63);
			$this->_addRequestField('vads_cust_status', 'Customer status (private or company)', "#^PRIVATE|COMPANY$#", false, 7);
			
			$this->_addRequestField('vads_ship_to_first_name', 'Shipping first name', $an63, false, 63);
			$this->_addRequestField('vads_ship_to_last_name', 'Shipping last name', $an63, false, 63);
			$this->_addRequestField('vads_ship_to_status', 'Shipping status (private or company)', "#^PRIVATE|COMPANY$#", false, 7);
			$this->_addRequestField('vads_ship_to_delivery_company_name', 'Name of the delivery company', $ans127, false, 127);
			$this->_addRequestField('vads_ship_to_speed', 'Speed of the shipping method', "#^STANDARD|EXPRESS$#", false, 8);
			$this->_addRequestField('vads_ship_to_type', 'Type of the shipping method', 
							"#^RECLAIM_IN_SHOP|RELAY_POINT|RECLAIM_IN_STATION|PACKAGE_DELIVERY_COMPANY|ETICKET$#", false, 24);
			
			$this->_addRequestField('vads_insurance_amount', 'The amount of insurance', '#^' . $supzero . '$#', false, 12);
			$this->_addRequestField('vads_tax_amount', 'The amount of tax', '#^' . $supzero . '$#', false, 12);
			$this->_addRequestField('vads_shipping_amount', 'The amount of shipping', '#^' . $supzero . '$#', false, 12);
			$this->_addRequestField('vads_nb_products', 'Number of products', '#^' . $supzero . '$#', false);
			
			// Set some default parameters
			$this->set('vads_version', 'V2');
			$this->set('vads_page_action', 'PAYMENT');
			$this->set('vads_action_mode', 'INTERACTIVE');
			$this->set('vads_payment_config', 'SINGLE');
			$timestamp = time();
			$this->set('vads_trans_id', $this->_generateTransId($timestamp));
			$this->set('vads_trans_date', gmdate('YmdHis', $timestamp));
		}
	
		/**
		 * Generate a trans_id.
		 * To be independent from shared/persistent counters, we use the number of 1/10seconds since midnight,
		 * which has the appropriate format (000000-899999) and has great chances to be unique.
		 * @return string the generated trans_id
		 * @access private
		 */
		function _generateTransId($timestamp) {
			list($usec, $sec) = explode(" ", microtime()); // microseconds, php4 compatible
			$temp = ($timestamp + $usec - strtotime('today 00:00')) * 10;
			$temp = sprintf('%06d', $temp);
	
			return $temp;
		}
	
		/**
		 * Shortcut function used in constructor to build requestParameters
		 * @param string $name
		 * @param string $label
		 * @param string $regex
		 * @param boolean $required
		 * @param mixed $value
		 * @return boolean true on success
		 * @access private
		 */
		function _addRequestField($name, $label, $regex, $required = false,
				$length = 255, $value = null) {
			$this->requestParameters[$name] = new PayzenField($name, $label, $regex,
					$required, $length);
			
			if($value !== null) {
				return $this->set($name, $value);
			} else {
				return true;
			}		
		}
	
		// **************************************
		// INTERNATIONAL FUNCTIONS
		// **************************************
	
		/**
		 * Returns an array of languages accepted by the PayZen payment page
		 * @static
		 * @return array[string]string
		 */
		function getSupportedLanguages() {
			return array(
				'fr' => 'French', 'de' => 'German', 'en' => 'English', 'es' => 'Spanish','zh' => 'Chinese', 'it' => 'Italian', 'ja' => 'Japanese', 'pt' => 'Portuguese','nl' => 'Dutch', 'sv' => 'Swedish'
			);
		}
		
		/**
		 * Returns true if the entered language is supported
		 * @static
		 * @param string $lang
		 * @return boolean
		 */
		function isSupportedLanguage($lang) {
			foreach ($this->getSupportedLanguages() as $code => $label) {
				if($code == strtolower($lang)) {
					return true;
				}
			}
			
			return false;
		}
	
		/**
		 * Return the list of currencies recognized by the PayZen platform
		 * @static
		 * @return array[int]PayzenCurrency 
		 */
		function getSupportedCurrencies() {
			$currencies = array(
				array('ARS', 32, 2), array('AUD', 36, 2), array('KHR', 116, 0), array('CAD', 124, 2), array('CNY', 156, 1), array('HRK', 191, 2), array('CZK', 203, 2), array('DKK', 208, 2), array('EKK', 233, 2), array('HKD', 344, 2), array('HUF', 348, 2), array('ISK', 352, 0), array('IDR', 360, 0), array('JPY', 392, 0), array('KRW', 410, 0), array('LVL', 428, 2), array('LTL', 440, 2), array('MYR', 458, 2), array('MXN', 484, 2), array('NZD', 554, 2), array('NOK', 578, 2), array('PHP', 608, 2), array('RUB', 643, 2), array('SGD', 702, 2), array('ZAR', 710, 2), array('SEK', 752, 2), array('CHF', 756, 2), array('THB', 764, 2), array('GBP', 826, 2), array('USD', 840, 2), array('TWD', 901, 1), array('RON', 946, 2), array('TRY', 949, 2), array('XOF', 952, 0), array('BGN', 975, 2), array('EUR', 978, 2), array('PLN', 985, 2), array('BRL', 986, 2)
			);
			
			$payzenCurrencies = array();
			
			foreach($currencies as $currency) {
				$payzenCurrencies[] = new PayzenCurrency($currency[0], $currency[1], $currency[2]);
			}
			
			return $payzenCurrencies;
		}
	
		/**
		 * Return a currency from its iso 3-letters code
		 * @static
		 * @param string $alpha3
		 * @return PayzenCurrency
		 */
		function findCurrencyByAlphaCode($alpha3) {
			$list = $this->getSupportedCurrencies();
			foreach ($list as $currency) {
				/** @var PayzenCurrency $currency */
				if ($currency->alpha3 == $alpha3) {
					return $currency;
				}
			}
			return null;
		}
	
		/**
		 * Returns a currency form its iso numeric code
		 * @static
		 * @param int $num
		 * @return PayzenCurrency
		 */
		function findCurrencyByNumCode($numeric) {
			$list = $this->getSupportedCurrencies();
			foreach ($list as $currency) {
				/** @var PayzenCurrency $currency */
				if ($currency->num == $numeric) {
					return $currency;
				}
			}
			return null;
		}
	
		/**
		 * Returns a currency numeric code from its 3-letters code
		 * @static
		 * @param string $alpha3
		 * @return int
		 */
		function getCurrencyNumCode($alpha3) {
			$currency = $this->findCurrencyByAlphaCode($alpha3);
			return is_a($currency, 'PayzenCurrency') ? $currency->num : null;
		}
		
		/**
		 * Returns an array of card types accepted by the PayZen payment platform
		 * @static
		 * @return array[string]string
		 */
		function getSupportedCardTypes() {
			return array(
				'CB' => 'CB', 'VISA' => 'Visa', 'VISA_ELECTRON' => 'Visa Electron', 'MASTERCARD' => 'Mastercard','MAESTRO' => 'Maestro', 'AMEX' => 'American Express', 'E-CARTEBLEUE' => 'E-Carte bleue'
			);
		}
	
		// **************************************
		// GETTERS/SETTERS
		// **************************************
		/**
		 * Shortcut for setting multiple values with one array
		 * @param array[string]mixed $parameters
		 * @return boolean true on success
		 */
		function setFromArray($parameters) {
			$ok = true;
			foreach ($parameters as $name => $value) {
				$ok &= $this->set($name, $value);
			}
			return $ok;
		}
	
		/**
		 * General getter.
		 * Retrieve an api variable from its name. Automatically add 'vads_' to the name if necessary.
		 * Example : <code><?php $siteId = $api->get('site_id'); ?></code>
		 * @param string $name
		 * @return mixed null if $name was not recognised
		 */
		function get($name) {
			if (!$name || !is_string($name)) {
				return null;
			}
	
			// V1/shortcut notation compatibility
			$name = (substr($name, 0, 5) != 'vads_') ? 'vads_' . $name : $name;
	
			if ($name == 'vads_key_test') {
				return $this->keyTest;
			} elseif ($name == 'vads_key_prod') {
				return $this->keyProd;
			} elseif ($name == 'vads_platform_url') {
				return $this->platformUrl;
			} elseif ($name == 'vads_redirect_enabled') {
				return $this->redirectEnabled;
			} elseif (array_key_exists($name, $this->requestParameters)) {
				return $this->requestParameters[$name]->getValue();
			} else {
				return null;
			}
		}
	
		/**
		 * General setter.
		 * Set an api variable with its name and the provided value. Automatically add 'vads_' to the name if necessary.
		 * Example : <code><?php $api->set('site_id', '12345678'); ?></code>
		 * @param string $name
		 * @param mixed $value
		 * @return boolean true on success
		 */
		function set($name, $value) {
			if (!$name || !is_string($name)) {
				return false;
			}
	
			// V1/shortcut notation compatibility
			$name = (substr($name, 0, 5) != 'vads_') ? 'vads_' . $name : $name;
	
			// Convert the parameters if they are not encoded in utf8
			if($this->encoding !== "UTF-8") {
				$value = iconv($this->encoding, "UTF-8", $value);
			}
			
			// Search appropriate setter
			if ($name == 'vads_key_test') {
				return $this->setCertificate($value, 'TEST');
			} elseif ($name == 'vads_key_prod') {
				return $this->setCertificate($value, 'PRODUCTION');
			} elseif ($name == 'vads_platform_url') {
				return $this->setPlatformUrl($value);
			} elseif ($name == 'vads_redirect_enabled') {
				return $this->setRedirectEnabled($value);
			} elseif (array_key_exists($name, $this->requestParameters)) {
				return $this->requestParameters[$name]->setValue($value);
			} else {
				return false;
			}
		}
	
		/**
		 * Set target url of the payment form
		 * @param string $url
		 * @return boolean
		 */
		function setPlatformUrl($url) {
			if (!preg_match('#https?://([^/]+/)+#', $url)) {
				return false;
			}
			$this->platformUrl = $url;
			return true;
		}
	
		/**
		 * Enable/disable redirect_* parameters
		 * @param mixed $enabled false, '0', a null or negative integer or 'false' to disable
		 * @return boolean
		 */
		function setRedirectEnabled($enabled) {
			$this->redirectEnabled = !(!$enabled || $enabled == '0'
					|| strtolower($enabled) == 'false');
			return true;
		}
	
		/**
		 * Set TEST or PRODUCTION certificate
		 * @param string $key
		 * @param string $mode
		 * @return boolean true if the certificate could be set
		 */
		function setCertificate($key, $mode) {
			// Check format
			if (!preg_match('#\d{16}#', $key)) {
				return false;
			}
	
			if ($mode == 'TEST') {
				$this->keyTest = $key;
			} elseif ($mode == 'PRODUCTION') {
				$this->keyProd = $key;
			} else {
				return false;
			}
			return true;
		}
		
		/**
		* Add product infos as request parameters.
		* @param string $label
		* @param int $amount
		* @param int $qty
		* @param string $ref
		* @param string $type
		* @return boolean true if product infos are set correctly
		*/
		function addProductRequestField($label, $amount, $qty, $ref, $type) {
			$index = $this->get("nb_products") ? $this->get("nb_products") : 0;
			
			$ok = true;
			
			// Add product infos as request parameters 
			$ok &= $this->_addRequestField("vads_product_label" . $index, "Product label", '#^[^<>"+-]{0,255}$#', false, 255, $label);
			$ok &= $this->_addRequestField("vads_product_amount" . $index, "Product amount", '#^[1-9]\d*$#', false, 12, $amount);
			$ok &= $this->_addRequestField("vads_product_qty" . $index, "Product quantity", '#^[1-9]\d*$#', false, 255, $qty);
			$ok &= $this->_addRequestField("vads_product_ref" . $index, "Product reference", '#^[A-Za-z0-9]{0,64}$#', false, 64, $ref);
			$ok &= $this->_addRequestField("vads_product_type" . $index, "Product type", "#^".implode("|", $this->ACCORD_CATEGORIES)."$#", 
				false, 30, $type);
			
			// Increment the number of products
			$ok &= $this->set("nb_products", $index + 1);
			
			return $ok;
		}
		
		/**
		* Add extra info as a request parameter.
		* @param string $key
		* @param string $value
		* @return boolean true if extra info is set correctly
		*/
		function addExtInfoRequestField($key, $value) {
			return $this->_addRequestField("vads_ext_info_" . $key, "Extra info " . $key, '#^.{0,255}$#', false, 255, $value);
		}
		
	
		/**
		 * Return certificate according to current mode, false if mode was not set
		 * @return string|boolean
		 */
		function getCertificate() {
			switch ($this->requestParameters['vads_ctx_mode']
					->getValue()) {
				case 'TEST':
					return $this->keyTest;
					break;
	
				case 'PRODUCTION':
					return $this->keyProd;
					break;
	
				default:
					return false;
					break;
			}
		}
	
		/**
		 * Generate signature from a list of PayzenField
		 * @param array[string]PayzenField $fields
		 * @return string
		 * @access private
		 */
		function _generateSignatureFromFields($fields = null, $hashed = true) {
			$params = array();
			$fields = ($fields !== null) ? $fields : $this->requestParameters;
			foreach ($fields as $field) {
				if ($field->isRequired() || $field->isFilled()) {
					$params[$field->getName()] = $field->getValue();
				}
			}
			return $this->sign($params, $this->getCertificate(), $hashed);
		}
	
		/**
		 * Public static method to compute a PayZen signature. Parameters must be in utf-8.
		 * @param array[string]string $parameters payment gateway request/response parameters
		 * @param string $key shop certificate
		 * @param boolean $hashed set to false to get the raw, unhashed signature
		 * @access public
		 * @static
		 */
		function sign($parameters, $key, $hashed = true) {
			$signContent = "";
			ksort($parameters);
			foreach ($parameters as $name => $value) {
				if (substr($name, 0, 5) == 'vads_') {
					$signContent .= $value . '+';
				}
			}
			$signContent .= $key;
			$sign = $hashed ? sha1($signContent) : $signContent;
			return $sign;
		}
	
		// **************************************
		// REQUEST PREPARATION FUNCTIONS
		// **************************************
		/**
		 * Unset the value of optionnal fields if they are unvalid
		 */
		function clearInvalidOptionnalFields() {
			$fields = $this->getRequestFields();
			foreach ($fields as $field) {
				if (!$field->isValid() && !$field->isRequired()) {
					$field->setValue(null);
				}
			}
		}
		
		/**
		 * Check all payment fields
		 * @param array $errors will be filled with the name of invalid fields
		 * @return boolean
		 */
		function isRequestReady(&$errors = null) {
			$errors = is_array($errors) ? $errors : array();
			$fields = $this->getRequestFields();
			foreach ($fields as $field) {
				if (!$field->isValid()) {
					$errors[] = $field->getName();
				}
			}
			return sizeof($errors) == 0;
		}
	
		/**
		 * Return the list of fields to send to the payment gateway
		 * @return array[string]PayzenField a list of PayzenField or false if a parameter was invalid
		 * @see PayzenField
		 */
		function getRequestFields() {
			$fields = $this->requestParameters;
	
			// Filter redirect_parameters if redirect is disabled
			if (!$this->redirectEnabled) {
				$redirectFields = array(
						'vads_redirect_success_timeout',
						'vads_redirect_success_message',
						'vads_redirect_error_timeout',
						'vads_redirect_error_message');
				foreach ($redirectFields as $fieldName) {
					unset($fields[$fieldName]);
				}
			}
	
			foreach ($fields as $fieldName => $field) {
				if (!$field->isFilled() && !$field->isRequired()) {
					unset($fields[$fieldName]);
				}
			}
	
			// Compute signature
			$fields['signature']->setValue($this->_generateSignatureFromFields($fields));
	
			// Return the list of fields
			return $fields;
		}
	
		/**
		 * Return the url of the payment page with urlencoded parameters (GET-like url)
		 * @return boolean|string
		 */
		function getRequestUrl() {
			$fields = $this->getRequestFields();
	
			$url = $this->platformUrl . '?';
			foreach ($fields as $field) {
				if ($field->isFilled()) {
					$url .= $field->getName() . '=' . rawurlencode($field->getValue())
							. '&';
				}
			}
			$url = substr($url, 0, -1); // remove last &
			return $url;
		}
	
		/**
		 * Return the html form to send to the payment gateway
		 * @param string $enteteAdd
		 * @param string $inputType
		 * @param string $buttonValue
		 * @param string $buttonAdd
		 * @param string $buttonType
		 * @return string
		 */
		function getRequestHtmlForm($enteteAdd = '', $inputType = 'hidden',
				$buttonValue = 'Aller sur la plateforme de paiement', $buttonAdd = '',
				$buttonType = 'submit') {
	
			$html = "";
			$html .= '<form action="' . $this->platformUrl . '" method="POST" '
					. $enteteAdd . '>';
			$html .= "\n";
			$html .= $this->getRequestFieldsHtml('type="' . $inputType . '"');
			$html .= '<input type="' . $buttonType . '" value="' . $buttonValue . '" '
					. $buttonAdd . '/>';
			$html .= "\n";
			$html .= '</form>';
			return $html;
		}
	
		/**
		 * Return the html code of the form fields to send to the payment page
		 * @param string $inputAttributes
		 * @return string
		 */
		function getRequestFieldsHtml($inputAttributes = 'type="hidden"') {
			$fields = $this->getRequestFields();
			
			$html = '';
			$format = '<input name="%s" value="%s" ' . $inputAttributes . "/>\n";
			foreach ($fields as $field) {
				if ($field->isFilled()) {
					// Convert special chars to HTML entities to avoid data troncation
					$value = htmlspecialchars($field->getValue(), ENT_QUOTES, 'UTF-8');
					
					$html .= sprintf($format, $field->getName(), $value);
				}
			}
			return $html;
		}
		
		/**
		 * Return the html fields to send to the payment page as a key/value array 
		 * @return array[string][string]
		 */
		function getRequestFieldsArray() {
			$fields = $this->getRequestFields();
				
			$result = array();
			foreach ($fields as $field) {
				if ($field->isFilled()) {
					// Convert special chars to HTML entities to avoid data troncation
					$result[$field->getName()] = htmlspecialchars($field->getValue(), ENT_QUOTES, 'UTF-8');
				}
			}
			
			return $result;
		}
	
		/**
		 * PHP is not yet a sufficiently advanced technology to be indistinguishable from magic...
		 * so don't use magic_quotes, they mess up with the gateway response analysis.
		 * 
		 * @param array $potentiallyMagicallyQuotedData
		 */
		function uncharm($potentiallyMagicallyQuotedData) {
			if (get_magic_quotes_gpc()) {
				$sane = array();
				foreach ($potentiallyMagicallyQuotedData as $k => $v) {
					$saneKey = stripslashes($k);
					$saneValue = is_array($v) ? $this->uncharm($v) : stripslashes($v);
					$sane[$saneKey] = $saneValue;
				}
			} else {
				$sane = $potentiallyMagicallyQuotedData;
			}
			return $sane;
		}
	}

}

if(!@class_exists('PayzenResponse', false)) {
	/**
	 * Class representing the result of a transaction (sent by the check url or by the client return)
	 */
	class PayzenResponse {
		/**
		 * Raw response parameters array
		 * @var array
		 * @access private
		 */
		var $raw_response = array();
		/**
		 * Certificate used to check the signature
		 * @see PayzenApi::sign
		 * @var boolean
		 * @access private
		 */
		var $certificate;
		/**
		 * Value of vads_result
		 * @var string
		 * @access private
		 */
		var $code;
		/**
		 * Translation of $code (vads_result)
		 * @var string
		 * @access private
		 */
		var $message;
		/**
		 * Value of vads_extra_result
		 * @var string
		 * @access private
		 */
		var $extraCode;
		/**
		 * Translation of $extraCode (vads_extra_result)
		 * @var string
		 * @access private
		 */
		var $extraMessage;
		/**
		 * Value of vads_auth_result
		 * @var string
		 * @access private
		 */
		var $authCode;
		/**
		 * Translation of $authCode (vads_auth_result)
		 * @var string
		 * @access private
		 */
		var $authMessage;
		/**
		 * Value of vads_warranty_result
		 * @var string
		 * @access private
		 */
		var $warrantyCode;
		/**
		 * Translation of $warrantyCode (vads_warranty_result)
		 * @var string
		 * @access private
		 */
		var $warrantyMessage;
		/**
		 * Internal reference to PayzenApi for using util methods
		 * @var PayzenApi
		 * @access private
		 */
		var $api;
		
		/**
		 * Associative array containing human-readable translations of response codes. Initialized to french translations.
		 * @var array
		 * @access private
		 */
		var $translation = array(
				'no_code' => '',
				'no_translation' => '',
				'results' => array(
						'00' => 'Paiement ralis avec succs',
						'02' => 'Le commerant doit contacter la banque du porteur',
						'05' => 'Paiement refus',
						'17' => 'Annulation client',
						'30' => 'Erreur de format de la requte',
						'96' => 'Erreur technique lors du paiement'),
				'extra_results_default' => array(
						'empty' => 'Pas de contrle effectu',
						'00' => 'Tous les contrles se sont drouls avec succs',
						'02' => 'La carte a dpass l?encours autoris',
						'03' => 'La carte appartient  la liste grise du commerant',
						'04' => 'Le pays d?mission de la carte appartient  la liste grise du commerant',
						'05' => 'L?adresse IP appartient  la liste grise du commerant',
						'06' => 'Le code BIN appartient  la liste grise du commerant',
						'07' => 'Dtection d\'une e-carte bleue',
						'08' => 'Dtection d\'une carte commerciale nationale',
						'09' => 'Dtection d\'une carte commerciale trangre',
						'14' => 'La carte est une carte  autorisation systmatique',
						'20' => 'Aucun pays ne correspond (pays IP, pays carte, pays client)',
						'99' => 'Problme technique rencontr par le serveur lors du traitement d?un des contrles locaux'),
				'extra_results_30' => array(
						'00' => 'signature',
						'01' => 'version',
						'02' => 'merchant_site_id',
						'03' => 'transaction_id',
						'04' => 'date',
						'05' => 'validation_mode',
						'06' => 'capture_delay',
						'07' => 'config',
						'08' => 'payment_cards',
						'09' => 'amount',
						'10' => 'currency',
						'11' => 'ctx_mode',
						'12' => 'language',
						'13' => 'order_id',
						'14' => 'order_info',
						'15' => 'cust_email',
						'16' => 'cust_id',
						'17' => 'cust_title',
						'18' => 'cust_name',
						'19' => 'cust_address',
						'20' => 'cust_zip',
						'21' => 'cust_city',
						'22' => 'cust_country',
						'23' => 'cust_phone',
						'24' => 'url_success',
						'25' => 'url_refused',
						'26' => 'url_referral',
						'27' => 'url_cancel',
						'28' => 'url_return',
						'29' => 'url_error',
						'30' => 'identifier',
						'31' => 'contrib',
						'32' => 'theme_config',
						'34' => 'redirect_success_timeout',
						'35' => 'redirect_success_message',
						'36' => 'redirect_error_timeout',
						'37' => 'redirect_error_message',
						'38' => 'return_post_params',
						'39' => 'return_get_params',
						'40' => 'card_number',
						'41' => 'expiry_month',
						'42' => 'expiry_year',
						'43' => 'card_cvv',
						'44' => 'card_info',
						'45' => 'card_options',
						'46' => 'page_action',
						'47' => 'action_mode',
						'48' => 'return_mode',
						'50' => 'secure_mpi',
						'51' => 'secure_enrolled',
						'52' => 'secure_cavv',
						'53' => 'secure_eci',
						'54' => 'secure_xid',
						'55' => 'secure_cavv_alg',
						'56' => 'secure_status',
						'60' => 'payment_src',
						'61' => 'user_info',
						'62' => 'contracts',
						'70' => 'empty_params',
						'99' => 'other'),
				'auth_results' => array(
						'00' => 'transaction approuve ou traite avec succs',
						'02' => 'contacter l?metteur de carte',
						'03' => 'accepteur invalide',
						'04' => 'conserver la carte',
						'05' => 'ne pas honorer',
						'07' => 'conserver la carte, conditions spciales',
						'08' => 'approuver aprs identification',
						'12' => 'transaction invalide',
						'13' => 'montant invalide',
						'14' => 'numro de porteur invalide',
						'30' => 'erreur de format',
						'31' => 'identifiant de l?organisme acqureur inconnu',
						'33' => 'date de validit de la carte dpasse',
						'34' => 'suspicion de fraude',
						'41' => 'carte perdue',
						'43' => 'carte vole',
						'51' => 'provision insuffisante ou crdit dpass',
						'54' => 'date de validit de la carte dpasse',
						'56' => 'carte absente du fichier',
						'57' => 'transaction non permise  ce porteur',
						'58' => 'transaction interdite au terminal',
						'59' => 'suspicion de fraude',
						'60' => 'l?accepteur de carte doit contacter l?acqureur',
						'61' => 'montant de retrait hors limite',
						'63' => 'rgles de scurit non respectes',
						'68' => 'rponse non parvenue ou reue trop tard',
						'90' => 'arrt momentan du systme',
						'91' => 'metteur de cartes inaccessible',
						'96' => 'mauvais fonctionnement du systme',
						'94' => 'transaction duplique',
						'97' => 'chance de la temporisation de surveillance globale',
						'98' => 'serveur indisponible routage rseau demand  nouveau',
						'99' => 'incident domaine initiateur'),
				'warranty_results' => array(
						'YES' => 'Le paiement est garanti',
						'NO' => 'Le paiement n\'est pas garanti',
						'UNKNOWN' => 'Suite  une erreur technique, le paiment ne peut pas tre garanti'));
	
		/**
		 * Constructor for PayzenResponse class. Prepare to analyse check url or return url call.
		 * @param array[string]string $parameters $_REQUEST by default
		 * @param string $ctx_mode
		 * @param string $key_test
		 * @param string $key_prod
		 * @param string $encoding
		 */
		function PayzenResponse($parameters = null, $ctx_mode = null, $key_test = null, $key_prod = null) {
			
			$this->api = new PayzenApi(); // Use default API encoding (UTF-8) since the payment platform returns UTF-8 data 
			
			if(is_null($parameters)) {
				$parameters = $_REQUEST;
			}
			$parameters = $this->api->uncharm($parameters);
				
			// Load site credentials if provided
			if (!is_null($ctx_mode)) {
				$this->api->set('vads_ctx_mode', $ctx_mode);
			}
			if (!is_null($key_test)) {
				$this->api->set('vads_key_test', $key_test);
			}
			if (!is_null($key_prod)) {
				$this->api->set('vads_key_prod', $key_prod);
			}
			
			$this->load($parameters, $this->api->getCertificate());
		}
		
		/**
		 * Load response codes and translations from a parameter array.
		 * @param array[string]string $raw
		 * @param boolean $authentified
		 */
		function load($raw, $certificate) {
			$this->raw_response = is_array($raw) ? $raw : array();
			$this->certificate = $certificate;
	
			// Get codes
			$code = $this->_findInArray('vads_result', $raw, null);
			$extraCode = $this->_findInArray('vads_extra_result', $raw, null);
			$authCode = $this->_findInArray('vads_auth_result', $raw, null);
			$warrantyCode = $this->_findInArray('vads_warranty_code', $raw, null);
	
			// Common translations
			$noCode = $this->translation['no_code'];
			$noTrans = $this->translation['no_translation'];
	
			// Result and extra result
			if ($code == null) {
				$message = $noCode;
				$extraMessage = ($extraCode == null) ? $noCode : $noTrans;
			} else {
				$message = $this->_findInArray($code, $this->translation['results'],
								$noTrans);
	
				if ($extraCode == null) {
					$extraMessage = $noCode;
				} elseif ($code == 30) {
					$extraMessage = $this->_findInArray($extraCode,
									$this->translation['extra_results_30'], $noTrans);
				} else {
					$extraMessage = $this->_findInArray($extraCode,
									$this->translation['extra_results_default'], $noTrans);
				}
			}
	
			// auth_result
			if ($authCode == null) {
				$authMessage = $noCode;
			} else {
				$authMessage = $this->_findInArray($authCode,
								$this->translation['auth_results'], $noTrans);
			}
	
			// warranty_result
			if ($warrantyCode == null) {
				$warrantyMessage = $noCode;
			} else {
				$warrantyMessage = $this->_findInArray($warrantyCode,
								$this->translations['warranty_results'], $noTrans);
			}
	
			$this->code = $code;
			$this->message = $message;
			$this->authCode = $authCode;
			$this->authMessage = $authMessage;
			$this->extraCode = $extraCode;
			$this->extraMessage = $extraMessage;
			$this->warrantyCode = $warrantyCode;
			$this->warrantyMessage = $warrantyMessage;
		}
	
		/**
		 * Check response signature
		 * @return boolean
		 */
		function isAuthentified() {
			return $this->api->sign($this->raw_response, $this->certificate)
					== $this->getSignature();
		}
	
		/**
		 * Return the signature computed from the received parameters, for log/debug purposes.
		 * @param boolean $hashed apply sha1, false by default
		 * @return string
		 */
		function getComputedSignature($hashed = false) {
			return $this->api->sign($this->raw_response, $this->certificate, $hashed);
		}
	
		/**
		 * Check if the payment was successful (waiting confirmation or captured)
		 * @return boolean
		 */
		function isAcceptedPayment() {
			return $this->code == '00';
		}
	
		/**
		 * Check if the payment is waiting confirmation (successful but the amount has not been transfered and is not yet guaranteed)
		 * @return boolean
		 */
		function isPendingPayment() {
			return $this->get('auth_mode') == 'MARK';
		}
	
		/**
		 * Check if the payment process was interrupted by the client
		 * @return boolean
		 */
		function isCancelledPayment() {
			return $this->code == '17';
		}
	
		/**
		 * Return the value of a response parameter.
		 * @param string $name
		 * @return string
		 */
		function get($name) {
			// Manage shortcut notations by adding 'vads_'
			$name = (substr($name, 0, 5) != 'vads_') ? 'vads_' . $name : $name;
			
			return @$this->raw_response[$name];
		}
		
		/**
		* Shortcut for getting ext_info_* fields. 
		* @param string $key 
		* @return string
		*/
		function getExtInfo($key) {
			return $this->get("ext_info_$key");
		}
		
		/**
		* Returns the expected signature received from gateway.
		* @return string
		*/
		function getSignature() {
			return @$this->raw_response['signature'];
		}
	
		/**
		 * Return the paid amount converted from cents (or currency equivalent) to a decimal value
		 * @return float
		 */
		function getFloatAmount() {
			$currency = $this->api->findCurrencyByNumCode($this->get('currency'));
			return $currency->convertAmountToFloat($this->get('amount'));
		}
	
		/**
		 * Return a short description of the payment result, useful for logging
		 * @return string
		 */
		function getLogString() {
			$log = $this->code . ' : ' . $this->message;
			if ($this->code == '30') {
				$log .= ' (' . $this->extraCode . ' : ' . $this->extraMessage . ')';
			}
			return $log;
		}
	
		/**
		 * Return a formatted string to output as a response to the check url call
		 * @param string $case shortcut code for current situations. Most useful : payment_ok, payment_ko, auth_fail
		 * @param string $extraMessage some extra information to output to the payment gateway
		 * @return string
		 */
		function getOutputForGateway($case = '', $extraMessage = '', $originalEncoding="UTF-8") {
			$success = false;
			$message = '';
	
			// Messages prdfinis selon le cas
			$cases = array(
					'payment_ok' => array(true, 'Paiement valide traite'),
					'payment_ko' => array(true, 'Paiement invalide traite'),
					'payment_ok_already_done' => array(true, 'Paiement valide traite, deja enregistre'),
					'payment_ko_already_done' => array(true, 'Paiement invalide traite, deja enregistre'),
					'order_not_found' => array(false, 'Impossible de retrouver la commande'),
					'payment_ko_on_order_ok' => array(false, 'Code paiement invalide recu pour une commande deja validee'),
					'auth_fail' => array(false, 'Echec authentification'),
					'ok' => array(true, ''),
					'ko' => array(false, ''));
	
			if (array_key_exists($case, $cases)) {
				$success = $cases[$case][0];
				$message = $cases[$case][1];
			}
	
			$message .= ' ' . $extraMessage;
			$message = str_replace("\n", '', $message);
			
			// Set original CMS encoding to convert if necessary response to send to platform
			$encoding = in_array(strtoupper($originalEncoding), $this->api->SUPPORTED_ENCODINGS) ? strtoupper($originalEncoding) : "UTF-8";
			
			if($encoding !== "UTF-8") {
				$message = iconv($encoding, "UTF-8", $message);
			}
	
			$response = '';
			$response .= '<span style="display:none">';
			$response .= $success ? "OK-" : "KO-";
			$response .= $this->get('trans_id');
			$response .= ($message === ' ') ? "\n" : "=$message\n";
			$response .= '</span>';
			return $response;
		}
	
		/**
		 * Private shortcut function
		 * @param string $value
		 * @param array[string]string $translations
		 * @param string $defaultTransation
		 * @access private
		 */
		function _findInArray($key, $array, $default) {
			if (is_array($array) && array_key_exists($key, $array)) {
				return $array[$key];
			}
			return $default;
		}
	}
}

if(!@class_exists('PayzenField', false)) {
	/**
	 * Class representing a field of the form to send to the payment gateway
	 */
	class PayzenField {
		/**
		 * Field's name. Matches the html input attribute
		 * @var string
		 * @access private
		 */
		var $name;
		/**
		 * Field's label in english, to be used by translation systems
		 * @var string
		 * @access private
		 */
		var $label;
		/**
		 * Field's maximum length. Matches the html text input attribute
		 * @var int
		 * @access private
		 */
		var $length;
		/**
		 * PCRE regular expression the field value must match
		 * @var string
		 * @access private
		 */
		var $regex;
		/**
		 * Whether the form requires the field to be set (even to an empty string)
		 * @var boolean
		 * @access private
		 */
		var $required;
		/**
		 * Field's value. Null or string
		 * @var string
		 * @access private
		 */
		var $value = null;
	
		/**
		 * Constructor
		 * @param string $name
		 * @param string $label
		 * @param string $regex
		 * @param boolean $required
		 * @param string $value
		 * @return PayzenField
		 */
		function PayzenField($name, $label, $regex, $required = false, $length = 255) {
			$this->name = $name;
			$this->label = $label;
			$this->regex = $regex;
			$this->required = $required;
			$this->length = $length;
		}
	
		/**
		 * Setter for value
		 * @param mixed $value
		 * @return boolean true if the value is valid
		 */
		function setValue($value) {
			$value = ($value === null) ? null : (string) $value;
			// We save value even if invalid (in case the validate function is too restrictive, it happened once) ...
			$this->value = $value;
			if (!$this->validate($value)) {
				// ... but we return a "false" warning
				return false;
			}
			return true;
		}
	
		/**
		 * Checks the current value
		 * @return boolean false if the current value is invalid or null and required
		 */
		function isValid() {
			return $this->validate($this->value);
		}
	
		/**
		 * Check if a value is valid for this field
		 * @param string $value
		 * @return boolean
		 */
		function validate($value) {
			if ($value === null && $this->isRequired()) {
				return false;
			}
			if ($value !== null && !preg_match($this->regex, $value)) {
				return false;
			}
			return true;
		}
	
		/**
		 * Setter for the required attribute
		 * @param boolean $required
		 */
		function setRequired($required) {
			$this->required = (boolean) $required;
		}
	
		/**
		 * Is the field required in the payment request ?
		 * @return boolean
		 */
		function isRequired() {
			return $this->required;
		}
	
		/**
		 * Return the current value of the field.
		 * @return string
		 */
		function getValue() {
			return $this->value;
		}
	
		/**
		 * Return the name (html attribute) of the field.
		 * @return string
		 */
		function getName() {
			return $this->name;
		}
	
		/**
		 * Return the english human-readable name of the field.
		 * @return string
		 */
		function getLabel() {
			return $this->label;
		}
	
		/**
		 * Return the maximum length of the field's value.
		 * @return number
		 */
		function getLength() {
			return $this->length;
		}
	
		/**
		 * Has a value been set ?
		 * @return boolean
		 */
		function isFilled() {
			return !is_null($this->getValue());
		}
	}
}

if(!@class_exists('PayzenCurrency', false)) {
	/**
	 * Class representing a currency, used for converting alpha/numeric iso codes and float/integer amounts
	 */
	class PayzenCurrency {
		var $alpha3;
		var $num;
		var $decimals;
	
		function PayzenCurrency($alpha3, $num, $decimals = 2) {
			$this->alpha3 = $alpha3;
			$this->num = $num;
			$this->decimals = $decimals;
		}
	
		function convertAmountToInteger($float) {
			$coef = pow(10, $this->decimals);
	
			return intval(strval($float * $coef));
		}
	
		function convertAmountToFloat($integer) {
			$coef = pow(10, $this->decimals);
	
			return floatval($integer) / $coef;
		}
	}
}



if(!@class_exists('PayzenMultiApi', false)) {
	/**
	 * Class managing multi payment specific actions
	 * @version 2.2
	 */
	class PayzenMultiApi extends PayzenApi {
	
		/**
		 * Constructor.
		 */
		function PayzenMultiApi($encoding="UTF-8") {
			// call parent class constructor
			parent::PayzenApi($encoding);
		}
	
		/**
		* Set multi payment configuration
		* @param $total_in_cents total order amount in cents
		* @param $first_in_cents amount of the first payment in cents
		* @param $count total number of payments
		* @param $period number of days between 2 payments 
		* @return boolean true on success
		*/
		function setMultiPayment($total_in_cents = null, $first_in_cents = null, $count = 3, $period = 30) {
			$result = false;
			
			if (is_numeric($count) && $count > 1 && is_numeric($period) && $period > 0) {
				// Valeurs par dfaut pour first et total
				$total_in_cents = ($total_in_cents === null) ? $this->get('amount')	: $total_in_cents;
				$first_in_cents = ($first_in_cents === null) ? round($total_in_cents / $count) : $first_in_cents;
	
				// Vrification des paramtres
				if (is_numeric($total_in_cents) && $total_in_cents > $first_in_cents
						&& $total_in_cents > 0 && is_numeric($first_in_cents)
						&& $first_in_cents > 0) {
					// Enregistrement du paramtres payment_config
					$payment_config = 'MULTI:first=' . $first_in_cents . ';count=' . $count	. ';period=' . $period;
					$result = $this->set('amount', $total_in_cents);
					if ($result === true) {
						// premier set ok, on continue
						$result = $this->set('payment_config', $payment_config);
					}
				}
			}
	
			return $result;
		}
	}
}


?>